﻿using System;

namespace Zahlenketten
{
    class EvenRange : Enumerator<Int32>
    {
        Enumerator<Int32> it;
        Int32 current;

        public EvenRange(Enumerator<Int32> it)
        {
            this.it = it;
            this.current = -1;
        }

        public Int32 Current
        {
            get { return current; }
        }

        public Boolean Next()
        {
            while (it.Next())
            {
                if (it.Current % 2 == 0)
                {
                    current = it.Current;
                    return true;
                }
            }

            return false;
        }

        public void Reset()
        {
            this.current = -1;
            this.it.Reset();
        }
    }
}
